#This program identifies the amino-acid usage frequency at each position of the CDR3 sequence for sequences of identical lengths
import re, os, sys, csv, collections

def getCount(seq):
    aa_dict = collections.defaultdict(int)
    for s in seq:
        aa_dict[s] += 1
    return aa_dict

def getUsage(seq, info):
    if len(seq) in info:
        for i in range(1, len(seq)+1):
            info[len(seq)][i] += seq[i-1]
    else:
        position = {}
        for i in range(1, len(seq)+1):
            position[i] = seq[i-1]
        info[len(seq)] = position
    if 'Length' in info:
        for i in range(1, len(seq)+1):
            if i in info['Length']:
                info['Length'][i] += seq[i-1]
            else:
                info['Length'][i] = seq[i-1]
    else:
        position = {}
        for i in range(1, len(seq)+1):
            position[i] = seq[i-1]
        info['Length'] = position
        
overall_5, overall_3, count, index = {}, {}, 0, 0
f = open('C:\\Users\\Harsha\\Documents\\Immunology\\Kappler\\Harsha_454_Files\\B6Naive454Data\\CD4VJ-4.csv', 'r')
for line in f:
    if re.search('Strain', line) or line == '\n':
        temp = re.sub('\n', '', line).split(',')
        for i in range(len(temp)):
            if temp[i] == 'CDR3 Protein':
                index = i
                break
        continue
    temp = re.sub('\n', '', line).split(',')
    if len(temp[index].strip()) == 0 or re.search('\*', temp[index]):
        continue
    getUsage(temp[index], overall_5)
    getUsage(temp[index][::-1], overall_3)
    count += 1
    if count%500 == 0:
        print 'Total Sequences Parsed: ' + str(count)
f.close()

print count
aa_list = ['A', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'Y']

for length in overall_5:
    f = open('C:\\Users\\Harsha\\Documents\\Immunology\\Kappler\\Harsha_454_Files\\AA_Usage\\N_Terminus_Length_' + str(length) + '.csv', 'wb')
    writer = csv.writer(f)
    writer.writerows([(['Position'] + aa_list)])
    for pos in overall_5[length]:
        info = [pos]
        for aa in aa_list:
            if aa in overall_5[length][pos]:
                info.append(overall_5[length][pos].count(aa))
            else:
                info.append(0)
        writer.writerows([tuple(info)])
    f.close()

for length in overall_3:
    f = open('C:\\Users\\Harsha\\Documents\\Immunology\\Kappler\\Harsha_454_Files\\AA_Usage\\C_Terminus_Length_' + str(length) + '.csv', 'wb')
    writer = csv.writer(f)
    writer.writerows([(['Position'] + aa_list)])
    for pos in overall_3[length]:
        info = [pos]
        for aa in aa_list:
            if aa in overall_3[length][pos]:
                info.append(overall_3[length][pos].count(aa))
            else:
                info.append(0)
        writer.writerows([tuple(info)])
    f.close() 

